Index: /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90
===================================================================
--- /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 3582)
+++ /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 3583)
@@ -11,4 +11,5 @@
    !!            3.3  !  2010-09  (D.Storkey) add ice boundary conditions
    !!            3.4  !  2011     (D. Storkey) rewrite in preparation for OBC-BDY merge
+   !!            3.4  !  2012     (J. Chanut) straight open boundary case update
    !!----------------------------------------------------------------------
 #if defined key_bdy
@@ -26,4 +27,6 @@
    USE lib_mpp         ! for mpp_sum  
    USE iom             ! I/O
+   USE sbctide, ONLY: lk_tide ! Tidal forcing or not
+   USE phycst, ONLY: rday
 
    IMPLICIT NONE
@@ -32,4 +35,13 @@
    PUBLIC   bdy_init   ! routine called in nemo_init
 
+   INTEGER, PARAMETER          :: jp_nseg = 100
+   INTEGER, PARAMETER          :: nrimmax = 20 ! maximum rimwidth in structured
+                                               ! open boundary data files
+   ! Straight open boundary segment parameters:
+   INTEGER  :: nbdysege, nbdysegw, nbdysegn, nbdysegs 
+   INTEGER, DIMENSION(jp_nseg) :: jpieob, jpjedt, jpjeft, npckge
+   INTEGER, DIMENSION(jp_nseg) :: jpiwob, jpjwdt, jpjwft, npckgw
+   INTEGER, DIMENSION(jp_nseg) :: jpjnob, jpindt, jpinft, npckgn
+   INTEGER, DIMENSION(jp_nseg) :: jpjsob, jpisdt, jpisft, npckgs
    !!----------------------------------------------------------------------
    !! NEMO/OPA 4.0 , NEMO Consortium (2011)
@@ -53,10 +65,7 @@
       ! namelist variables
       !-------------------
-      INTEGER, PARAMETER          :: jp_nseg = 100
-      INTEGER                     :: nbdysege, nbdysegw, nbdysegn, nbdysegs 
-      INTEGER, DIMENSION(jp_nseg) :: jpieob, jpjedt, jpjeft
-      INTEGER, DIMENSION(jp_nseg) :: jpiwob, jpjwdt, jpjwft
-      INTEGER, DIMENSION(jp_nseg) :: jpjnob, jpindt, jpinft
-      INTEGER, DIMENSION(jp_nseg) :: jpjsob, jpisdt, jpisft
+      CHARACTER(LEN=80),DIMENSION(jpbgrd)  ::   clfile
+      CHARACTER(LEN=1)   ::   ctypebdy
+      INTEGER :: nbdyind, nbdybeg, nbdyend
 
       ! local variables
@@ -66,18 +75,19 @@
       INTEGER  ::   iw, ie, is, in, inum, id_dummy         !   -       -
       INTEGER  ::   igrd_start, igrd_end, jpbdta           !   -       -
+      INTEGER  ::   jpbdtau, jpbdtas                       !   -       -
+      INTEGER  ::   ib_bdy1, ib_bdy2, ib1, ib2             !   -       -
       INTEGER, POINTER  ::  nbi, nbj, nbr                  ! short cuts
       REAL   , POINTER  ::  flagu, flagv                   !    -   -
       REAL(wp) ::   zefl, zwfl, znfl, zsfl                 ! local scalars
-      INTEGER, DIMENSION (2)                ::   kdimsz
+      INTEGER, DIMENSION (2)                  ::   kdimsz
       INTEGER, DIMENSION(jpbgrd,jp_bdy)       ::   nblendta         ! Length of index arrays 
       INTEGER, ALLOCATABLE, DIMENSION(:,:,:)  ::   nbidta, nbjdta   ! Index arrays: i and j indices of bdy dta
       INTEGER, ALLOCATABLE, DIMENSION(:,:,:)  ::   nbrdta           ! Discrete distance from rim points
-      REAL(wp), DIMENSION(jpidta,jpjdta)    ::   zmask            ! global domain mask
-      CHARACTER(LEN=80),DIMENSION(jpbgrd)  ::   clfile
-      CHARACTER(LEN=1),DIMENSION(jpbgrd)   ::   cgrid
+      CHARACTER(LEN=1),DIMENSION(jpbgrd)      ::   cgrid
       !!
       NAMELIST/nambdy/ nb_bdy, ln_coords_file, cn_coords_file,             &
          &             ln_mask_file, cn_mask_file, nn_dyn2d, nn_dyn2d_dta, &
          &             nn_dyn3d, nn_dyn3d_dta, nn_tra, nn_tra_dta,         &  
+         &             ln_tra_dmp, ln_dyn3d_dmp, rn_time_dmp,              &
 #if defined key_lim2
          &             nn_ice_lim2, nn_ice_lim2_dta,                       &
@@ -85,8 +95,5 @@
          &             ln_vol, nn_volctl, nn_rimwidth
       !!
-      NAMELIST/nambdy_index/ nbdysege, jpieob, jpjedt, jpjeft,             &
-                             nbdysegw, jpiwob, jpjwdt, jpjwft,             &
-                             nbdysegn, jpjnob, jpindt, jpinft,             &
-                             nbdysegs, jpjsob, jpisdt, jpisft
+      NAMELIST/nambdy_index/ ctypebdy, nbdyind, nbdybeg, nbdyend
 
       !!----------------------------------------------------------------------
@@ -105,5 +112,5 @@
 
       cgrid= (/'t','u','v'/)
-
+      
       ! -----------------------------------------
       ! Initialise and read namelist parameters
@@ -121,4 +128,7 @@
       nn_tra(:)         = 0
       nn_tra_dta(:)     = -1  ! uninitialised flag
+      ln_tra_dmp(:)     = .false.
+      ln_dyn3d_dmp(:)   = .false.
+      rn_time_dmp(:)    = 1.
 #if defined key_lim2
       nn_ice_lim2(:)    = 0
@@ -135,5 +145,4 @@
       ! Check and write out namelist parameters
       ! -----------------------------------------
-
       !                                   ! control prints
       IF(lwp) WRITE(numout,*) '         nambdy'
@@ -158,7 +167,7 @@
         IF(lwp) WRITE(numout,*) 'Boundary conditions for barotropic solution:  '
         SELECT CASE( nn_dyn2d(ib_bdy) )                  
-          CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
-          CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
-          CASE( 2 )      ;   IF(lwp) WRITE(numout,*) '      Flather radiation condition'
+          CASE(jp_none)         ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
+          CASE(jp_frs)          ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
+          CASE(jp_flather)      ;   IF(lwp) WRITE(numout,*) '      Flather radiation condition'
           CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for nn_dyn2d' )
         END SELECT
@@ -171,4 +180,7 @@
               CASE DEFAULT   ;   CALL ctl_stop( 'nn_dyn2d_dta must be between 0 and 3' )
            END SELECT
+           IF (( nn_dyn2d_dta(ib_bdy) .ge. 2 ).AND.(.NOT.lk_tide)) THEN
+             CALL ctl_stop( 'You must activate key_tide to add tidal forcing at open boundaries' )
+           ENDIF
         ENDIF
         IF(lwp) WRITE(numout,*)
@@ -176,6 +188,8 @@
         IF(lwp) WRITE(numout,*) 'Boundary conditions for baroclinic velocities:  '
         SELECT CASE( nn_dyn3d(ib_bdy) )                  
-          CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
-          CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
+          CASE(jp_none)  ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
+          CASE(jp_frs)   ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
+          CASE( 2 )      ;   IF(lwp) WRITE(numout,*) '      Specified value'
+          CASE( 3 )      ;   IF(lwp) WRITE(numout,*) '      Zero baroclinic velocities (runoff case)'
           CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for nn_dyn3d' )
         END SELECT
@@ -187,10 +201,28 @@
            END SELECT
         ENDIF
+
+        IF ( ln_dyn3d_dmp(ib_bdy) ) THEN
+           IF ( nn_dyn3d(ib_bdy).EQ.0 ) THEN
+              IF(lwp) WRITE(numout,*) 'No open boundary condition for baroclinic velocities: ln_dyn3d_dmp is set to .false.'
+              ln_dyn3d_dmp(ib_bdy)=.false.
+           ELSEIF ( nn_dyn3d(ib_bdy).EQ.1 ) THEN
+              CALL ctl_stop( 'Use FRS OR relaxation' )
+           ELSE
+              IF(lwp) WRITE(numout,*) '      + baroclinic velocities relaxation zone'
+              IF(lwp) WRITE(numout,*) '      Damping time scale: ',rn_time_dmp(ib_bdy),' days'
+              IF((lwp).AND.rn_time_dmp(ib_bdy)<0) CALL ctl_stop( 'Time scale must be positive' )
+           ENDIF
+        ELSE
+           IF(lwp) WRITE(numout,*) '      NO relaxation on baroclinic velocities'
+        ENDIF
         IF(lwp) WRITE(numout,*)
 
         IF(lwp) WRITE(numout,*) 'Boundary conditions for temperature and salinity:  '
         SELECT CASE( nn_tra(ib_bdy) )                  
-          CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
-          CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
+          CASE(jp_none)  ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
+          CASE(jp_frs)   ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
+          CASE( 2 )      ;   IF(lwp) WRITE(numout,*) '      Specified value'
+          CASE( 3 )      ;   IF(lwp) WRITE(numout,*) '      Neumann conditions'
+          CASE( 4 )      ;   IF(lwp) WRITE(numout,*) '      Runoff conditions : Neumann for T and specified to 0.1 for salinity'
           CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for nn_tra' )
         END SELECT
@@ -201,4 +233,19 @@
               CASE DEFAULT   ;   CALL ctl_stop( 'nn_tra_dta must be 0 or 1' )
            END SELECT
+        ENDIF
+
+        IF ( ln_tra_dmp(ib_bdy) ) THEN
+           IF ( nn_tra(ib_bdy).EQ.0 ) THEN
+              IF(lwp) WRITE(numout,*) 'No open boundary condition for tracers: ln_tra_dmp is set to .false.'
+              ln_tra_dmp(ib_bdy)=.false.
+           ELSEIF ( nn_tra(ib_bdy).EQ.1 ) THEN
+              CALL ctl_stop( 'Use FRS OR relaxation' )
+           ELSE
+              IF(lwp) WRITE(numout,*) '      + T/S relaxation zone'
+              IF(lwp) WRITE(numout,*) '      Damping time scale: ',rn_time_dmp(ib_bdy),' days'
+              IF((lwp).AND.rn_time_dmp(ib_bdy)<0) CALL ctl_stop( 'Time scale must be positive' )
+           ENDIF
+        ELSE
+           IF(lwp) WRITE(numout,*) '      NO T/S relaxation'
         ENDIF
         IF(lwp) WRITE(numout,*)
@@ -221,21 +268,23 @@
 #endif
 
-        IF(lwp) WRITE(numout,*) 'Boundary rim width for the FRS scheme = ', nn_rimwidth(ib_bdy)
+        IF(lwp) WRITE(numout,*) '      Width of relaxation zone = ', nn_rimwidth(ib_bdy)
         IF(lwp) WRITE(numout,*)
 
       ENDDO
 
-     IF( ln_vol ) THEN                     ! check volume conservation (nn_volctl value)
-       IF(lwp) WRITE(numout,*) 'Volume correction applied at open boundaries'
-       IF(lwp) WRITE(numout,*)
-       SELECT CASE ( nn_volctl )
-         CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      The total volume will be constant'
-         CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      The total volume will vary according to the surface E-P flux'
-         CASE DEFAULT   ;   CALL ctl_stop( 'nn_volctl must be 0 or 1' )
-       END SELECT
-       IF(lwp) WRITE(numout,*)
-     ELSE
-       IF(lwp) WRITE(numout,*) 'No volume correction applied at open boundaries'
-       IF(lwp) WRITE(numout,*)
+     IF (nb_bdy .gt. 0) THEN
+        IF( ln_vol ) THEN                     ! check volume conservation (nn_volctl value)
+          IF(lwp) WRITE(numout,*) 'Volume correction applied at open boundaries'
+          IF(lwp) WRITE(numout,*)
+          SELECT CASE ( nn_volctl )
+            CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      The total volume will be constant'
+            CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      The total volume will vary according to the surface E-P flux'
+            CASE DEFAULT   ;   CALL ctl_stop( 'nn_volctl must be 0 or 1' )
+          END SELECT
+          IF(lwp) WRITE(numout,*)
+        ELSE
+          IF(lwp) WRITE(numout,*) 'No volume correction applied at open boundaries'
+          IF(lwp) WRITE(numout,*)
+        ENDIF
      ENDIF
 
@@ -247,87 +296,93 @@
       ! ---------------------------------------------
       REWIND( numnam )                    
+               
+      nblendta(:,:) = 0
+      nbdysege = 0
+      nbdysegw = 0
+      nbdysegn = 0
+      nbdysegs = 0
+      icount   = 0 ! count user defined segments
+      ! Dimensions below are used to allocate arrays to read external data
+      jpbdtas = 1 ! Maximum size of boundary data (structured case)
+      jpbdtau = 1 ! Maximum size of boundary data (unstructured case)
+
       DO ib_bdy = 1, nb_bdy
 
-         jpbdta = 1
          IF( .NOT. ln_coords_file(ib_bdy) ) THEN ! Work out size of global arrays from namelist parameters
  
+            icount = icount + 1
             ! No REWIND here because may need to read more than one nambdy_index namelist.
             READ  ( numnam, nambdy_index )
 
-            ! Automatic boundary definition: if nbdysegX = -1
-            ! set boundary to whole side of model domain.
-            IF( nbdysege == -1 ) THEN
-               nbdysege = 1
-               jpieob(1) = jpiglo - 1
-               jpjedt(1) = 2
-               jpjeft(1) = jpjglo - 1
-            ENDIF
-            IF( nbdysegw == -1 ) THEN
-               nbdysegw = 1
-               jpiwob(1) = 2
-               jpjwdt(1) = 2
-               jpjwft(1) = jpjglo - 1
-            ENDIF
-            IF( nbdysegn == -1 ) THEN
-               nbdysegn = 1
-               jpjnob(1) = jpjglo - 1
-               jpindt(1) = 2
-               jpinft(1) = jpiglo - 1
-            ENDIF
-            IF( nbdysegs == -1 ) THEN
-               nbdysegs = 1
-               jpjsob(1) = 2
-               jpisdt(1) = 2
-               jpisft(1) = jpiglo - 1
-            ENDIF
-
-            nblendta(:,ib_bdy) = 0
-            DO iseg = 1, nbdysege
-               igrd = 1
-               nblendta(igrd,ib_bdy) = nblendta(igrd,ib_bdy) + jpjeft(iseg) - jpjedt(iseg) + 1               
-               igrd = 2
-               nblendta(igrd,ib_bdy) = nblendta(igrd,ib_bdy) + jpjeft(iseg) - jpjedt(iseg) + 1               
-               igrd = 3
-               nblendta(igrd,ib_bdy) = nblendta(igrd,ib_bdy) + jpjeft(iseg) - jpjedt(iseg)               
-            ENDDO
-            DO iseg = 1, nbdysegw
-               igrd = 1
-               nblendta(igrd,ib_bdy) = nblendta(igrd,ib_bdy) + jpjwft(iseg) - jpjwdt(iseg) + 1               
-               igrd = 2
-               nblendta(igrd,ib_bdy) = nblendta(igrd,ib_bdy) + jpjwft(iseg) - jpjwdt(iseg) + 1               
-               igrd = 3
-               nblendta(igrd,ib_bdy) = nblendta(igrd,ib_bdy) + jpjwft(iseg) - jpjwdt(iseg)               
-            ENDDO
-            DO iseg = 1, nbdysegn
-               igrd = 1
-               nblendta(igrd,ib_bdy) = nblendta(igrd,ib_bdy) + jpinft(iseg) - jpindt(iseg) + 1               
-               igrd = 2
-               nblendta(igrd,ib_bdy) = nblendta(igrd,ib_bdy) + jpinft(iseg) - jpindt(iseg)               
-               igrd = 3
-               nblendta(igrd,ib_bdy) = nblendta(igrd,ib_bdy) + jpinft(iseg) - jpindt(iseg) + 1
-            ENDDO
-            DO iseg = 1, nbdysegs
-               igrd = 1
-               nblendta(igrd,ib_bdy) = nblendta(igrd,ib_bdy) + jpisft(iseg) - jpisdt(iseg) + 1               
-               igrd = 2
-               nblendta(igrd,ib_bdy) = nblendta(igrd,ib_bdy) + jpisft(iseg) - jpisdt(iseg)
-               igrd = 3
-               nblendta(igrd,ib_bdy) = nblendta(igrd,ib_bdy) + jpisft(iseg) - jpisdt(iseg) + 1               
-            ENDDO
-
-            nblendta(:,ib_bdy) = nblendta(:,ib_bdy) * nn_rimwidth(ib_bdy)
-            jpbdta = MAXVAL(nblendta(:,ib_bdy))               
-
+            SELECT CASE ( TRIM(ctypebdy) )
+              CASE( 'N' )
+                 IF( nbdyind == -1 ) THEN  ! Automatic boundary definition: if nbdysegX = -1
+                    nbdyind  = jpjglo - 2  ! set boundary to whole side of model domain.
+                    nbdybeg  = 2
+                    nbdyend  = jpiglo - 1
+                 ENDIF
+                 nbdysegn = nbdysegn + 1
+                 npckgn(nbdysegn) = ib_bdy ! Save bdy package number
+                 jpjnob(nbdysegn) = nbdyind
+                 jpindt(nbdysegn) = nbdybeg
+                 jpinft(nbdysegn) = nbdyend
+                 !
+              CASE( 'S' )
+                 IF( nbdyind == -1 ) THEN  ! Automatic boundary definition: if nbdysegX = -1
+                    nbdyind  = 2           ! set boundary to whole side of model domain.
+                    nbdybeg  = 2
+                    nbdyend  = jpiglo - 1
+                 ENDIF
+                 nbdysegs = nbdysegs + 1
+                 npckgs(nbdysegs) = ib_bdy ! Save bdy package number
+                 jpjsob(nbdysegs) = nbdyind
+                 jpisdt(nbdysegs) = nbdybeg
+                 jpisft(nbdysegs) = nbdyend
+                 !
+              CASE( 'E' )
+                 IF( nbdyind == -1 ) THEN  ! Automatic boundary definition: if nbdysegX = -1
+                    nbdyind  = jpiglo - 2  ! set boundary to whole side of model domain.
+                    nbdybeg  = 2
+                    nbdyend  = jpjglo - 1
+                 ENDIF
+                 nbdysege = nbdysege + 1 
+                 npckge(nbdysege) = ib_bdy ! Save bdy package number
+                 jpieob(nbdysege) = nbdyind
+                 jpjedt(nbdysege) = nbdybeg
+                 jpjeft(nbdysege) = nbdyend
+                 !
+              CASE( 'W' )
+                 IF( nbdyind == -1 ) THEN  ! Automatic boundary definition: if nbdysegX = -1
+                    nbdyind  = 2           ! set boundary to whole side of model domain.
+                    nbdybeg  = 2
+                    nbdyend  = jpjglo - 1
+                 ENDIF
+                 nbdysegw = nbdysegw + 1
+                 npckgw(nbdysegw) = ib_bdy ! Save bdy package number
+                 jpiwob(nbdysegw) = nbdyind
+                 jpjwdt(nbdysegw) = nbdybeg
+                 jpjwft(nbdysegw) = nbdyend
+                 !
+              CASE DEFAULT   ;   CALL ctl_stop( 'ctypebdy must be N, S, E or W' )
+            END SELECT
+
+            ! For simplicity we assume that in case of straight bdy, arrays have the same length
+            ! (even if it is true that last tangential velocity points
+            ! are useless). This simplifies a little bit boundary data format (and agrees with format
+            ! used so far in obc package)
+
+            nblendta(1:jpbgrd,ib_bdy) =  (nbdyend - nbdybeg + 1) * nn_rimwidth(ib_bdy)
+            jpbdtas = MAX(jpbdtas, (nbdyend - nbdybeg + 1))
+            IF (lwp.and.(nn_rimwidth(ib_bdy)>nrimmax)) &
+            & CALL ctl_stop( 'rimwidth must be lower than nrimmax' )
 
          ELSE            ! Read size of arrays in boundary coordinates file.
-
-
             CALL iom_open( cn_coords_file(ib_bdy), inum )
-            jpbdta = 1
             DO igrd = 1, jpbgrd
                id_dummy = iom_varid( inum, 'nbi'//cgrid(igrd), kdimsz=kdimsz )  
                nblendta(igrd,ib_bdy) = kdimsz(1)
-               jpbdta = MAX(jpbdta, kdimsz(1))
-            ENDDO
+               jpbdtau = MAX(jpbdtau, kdimsz(1))
+            ENDDO
+            CALL iom_close( inum )
 
          ENDIF 
@@ -335,176 +390,29 @@
       ENDDO ! ib_bdy
 
-      ! Allocate arrays
-      !---------------
-      ALLOCATE( nbidta(jpbdta, jpbgrd, nb_bdy), nbjdta(jpbdta, jpbgrd, nb_bdy),    &
-         &      nbrdta(jpbdta, jpbgrd, nb_bdy) )
-
-      ALLOCATE( dta_global(jpbdta, 1, jpk) )
+      IF (nb_bdy>0) THEN
+         jpbdta = MAXVAL(nblendta(1:jpbgrd,1:nb_bdy))
+
+         ! Allocate arrays
+         !---------------
+         ALLOCATE( nbidta(jpbdta, jpbgrd, nb_bdy), nbjdta(jpbdta, jpbgrd, nb_bdy),    &
+            &      nbrdta(jpbdta, jpbgrd, nb_bdy) )
+
+         ALLOCATE( dta_global(jpbdtau, 1, jpk) )
+         IF ( icount>0 ) ALLOCATE( dta_global2(jpbdtas, nrimmax, jpk) )
+         ! 
+      ENDIF
+
+      ! Now look for crossings in user (namelist) defined open boundary segments:
+      !--------------------------------------------------------------------------
+      IF ( icount>0 ) CALL bdy_ctl_seg
 
       ! Calculate global boundary index arrays or read in from file
-      !------------------------------------------------------------
-      REWIND( numnam )                    
+      !------------------------------------------------------------               
+      ! 1. Read global index arrays from boundary coordinates file.
       DO ib_bdy = 1, nb_bdy
 
-         IF( .NOT. ln_coords_file(ib_bdy) ) THEN ! Calculate global index arrays from namelist parameters
-
-            ! No REWIND here because may need to read more than one nambdy_index namelist.
-            READ  ( numnam, nambdy_index )
-
-            ! Automatic boundary definition: if nbdysegX = -1
-            ! set boundary to whole side of model domain.
-            IF( nbdysege == -1 ) THEN
-               nbdysege = 1
-               jpieob(1) = jpiglo - 1
-               jpjedt(1) = 2
-               jpjeft(1) = jpjglo - 1
-            ENDIF
-            IF( nbdysegw == -1 ) THEN
-               nbdysegw = 1
-               jpiwob(1) = 2
-               jpjwdt(1) = 2
-               jpjwft(1) = jpjglo - 1
-            ENDIF
-            IF( nbdysegn == -1 ) THEN
-               nbdysegn = 1
-               jpjnob(1) = jpjglo - 1
-               jpindt(1) = 2
-               jpinft(1) = jpiglo - 1
-            ENDIF
-            IF( nbdysegs == -1 ) THEN
-               nbdysegs = 1
-               jpjsob(1) = 2
-               jpisdt(1) = 2
-               jpisft(1) = jpiglo - 1
-            ENDIF
-
-            ! ------------ T points -------------
-            igrd = 1  
-            icount = 0
-            DO ir = 1, nn_rimwidth(ib_bdy)
-               ! east
-               DO iseg = 1, nbdysege
-                  DO ij = jpjedt(iseg), jpjeft(iseg)
-                     icount = icount + 1
-                     nbidta(icount, igrd, ib_bdy) = jpieob(iseg) - ir + 1
-                     nbjdta(icount, igrd, ib_bdy) = ij
-                     nbrdta(icount, igrd, ib_bdy) = ir
-                  ENDDO
-               ENDDO
-               ! west
-               DO iseg = 1, nbdysegw
-                  DO ij = jpjwdt(iseg), jpjwft(iseg)
-                     icount = icount + 1
-                     nbidta(icount, igrd, ib_bdy) = jpiwob(iseg) + ir - 1
-                     nbjdta(icount, igrd, ib_bdy) = ij
-                     nbrdta(icount, igrd, ib_bdy) = ir
-                  ENDDO
-               ENDDO
-               ! north
-               DO iseg = 1, nbdysegn
-                  DO ii = jpindt(iseg), jpinft(iseg)
-                     icount = icount + 1
-                     nbidta(icount, igrd, ib_bdy) = ii
-                     nbjdta(icount, igrd, ib_bdy) = jpjnob(iseg) - ir + 1
-                     nbrdta(icount, igrd, ib_bdy) = ir
-                  ENDDO
-               ENDDO
-               ! south
-               DO iseg = 1, nbdysegs
-                  DO ii = jpisdt(iseg), jpisft(iseg)
-                     icount = icount + 1
-                     nbidta(icount, igrd, ib_bdy) = ii
-                     nbjdta(icount, igrd, ib_bdy) = jpjsob(iseg) + ir - 1
-                     nbrdta(icount, igrd, ib_bdy) = ir
-                  ENDDO
-               ENDDO
-            ENDDO
-
-            ! ------------ U points -------------
-            igrd = 2  
-            icount = 0
-            DO ir = 1, nn_rimwidth(ib_bdy)
-               ! east
-               DO iseg = 1, nbdysege
-                  DO ij = jpjedt(iseg), jpjeft(iseg)
-                     icount = icount + 1
-                     nbidta(icount, igrd, ib_bdy) = jpieob(iseg) - ir
-                     nbjdta(icount, igrd, ib_bdy) = ij
-                     nbrdta(icount, igrd, ib_bdy) = ir
-                  ENDDO
-               ENDDO
-               ! west
-               DO iseg = 1, nbdysegw
-                  DO ij = jpjwdt(iseg), jpjwft(iseg)
-                     icount = icount + 1
-                     nbidta(icount, igrd, ib_bdy) = jpiwob(iseg) + ir - 1
-                     nbjdta(icount, igrd, ib_bdy) = ij
-                     nbrdta(icount, igrd, ib_bdy) = ir
-                  ENDDO
-               ENDDO
-               ! north
-               DO iseg = 1, nbdysegn
-                  DO ii = jpindt(iseg), jpinft(iseg) - 1
-                     icount = icount + 1
-                     nbidta(icount, igrd, ib_bdy) = ii
-                     nbjdta(icount, igrd, ib_bdy) = jpjnob(iseg) - ir + 1
-                     nbrdta(icount, igrd, ib_bdy) = ir
-                  ENDDO
-               ENDDO
-               ! south
-               DO iseg = 1, nbdysegs
-                  DO ii = jpisdt(iseg), jpisft(iseg) - 1
-                     icount = icount + 1
-                     nbidta(icount, igrd, ib_bdy) = ii
-                     nbjdta(icount, igrd, ib_bdy) = jpjsob(iseg) + ir - 1
-                     nbrdta(icount, igrd, ib_bdy) = ir
-                  ENDDO
-               ENDDO
-            ENDDO
-
-            ! ------------ V points -------------
-            igrd = 3  
-            icount = 0
-            DO ir = 1, nn_rimwidth(ib_bdy)
-               ! east
-               DO iseg = 1, nbdysege
-                  DO ij = jpjedt(iseg), jpjeft(iseg) - 1
-                     icount = icount + 1
-                     nbidta(icount, igrd, ib_bdy) = jpieob(iseg) - ir + 1
-                     nbjdta(icount, igrd, ib_bdy) = ij
-                     nbrdta(icount, igrd, ib_bdy) = ir
-                  ENDDO
-               ENDDO
-               ! west
-               DO iseg = 1, nbdysegw
-                  DO ij = jpjwdt(iseg), jpjwft(iseg) - 1
-                     icount = icount + 1
-                     nbidta(icount, igrd, ib_bdy) = jpiwob(iseg) + ir - 1
-                     nbjdta(icount, igrd, ib_bdy) = ij
-                     nbrdta(icount, igrd, ib_bdy) = ir
-                  ENDDO
-               ENDDO
-               ! north
-               DO iseg = 1, nbdysegn
-                  DO ii = jpindt(iseg), jpinft(iseg)
-                     icount = icount + 1
-                     nbidta(icount, igrd, ib_bdy) = ii
-                     nbjdta(icount, igrd, ib_bdy) = jpjnob(iseg) - ir
-                     nbrdta(icount, igrd, ib_bdy) = ir
-                  ENDDO
-               ENDDO
-               ! south
-               DO iseg = 1, nbdysegs
-                  DO ii = jpisdt(iseg), jpisft(iseg)
-                     icount = icount + 1
-                     nbidta(icount, igrd, ib_bdy) = ii
-                     nbjdta(icount, igrd, ib_bdy) = jpjsob(iseg) + ir - 1
-                     nbrdta(icount, igrd, ib_bdy) = ir
-                  ENDDO
-               ENDDO
-            ENDDO
-
-         ELSE            ! Read global index arrays from boundary coordinates file.
-
+         IF( ln_coords_file(ib_bdy) ) THEN
+
+            CALL iom_open( cn_coords_file(ib_bdy), inum )
             DO igrd = 1, jpbgrd
                CALL iom_get( inum, jpdom_unknown, 'nbi'//cgrid(igrd), dta_global(1:nblendta(igrd,ib_bdy),:,1) )
@@ -527,5 +435,4 @@
                IF (ibr_max < nn_rimwidth(ib_bdy))   &
                      CALL ctl_stop( 'nn_rimwidth is larger than maximum rimwidth in file',cn_coords_file(ib_bdy) )
-
             END DO
             CALL iom_close( inum )
